use std::fs::File;
use std::io::prelude::*;
use std::path::Path;

pub fn read_file_content(file_path: &Path) -> String {
    let mut file = match File::open(file_path) {
        Err(_) => panic!(
            "Erro ao abrir o arquivo: {}",
            file_path.to_str().expect("Erro #0101")
        ),
        Ok(file) => file,
    };
    let mut contents = String::new();
    match file.read_to_string(&mut contents) {
        Err(_) => panic!(
            "Erro ao acessar o arquivo: {}",
            file_path.to_str().expect("Erro #0102")
        ),
        Ok(_) => (),
    };
    contents
}

pub fn write_file(file_path: &Path, content: String) {
    let display = file_path.display();
    let mut file = match File::create(file_path) {
        Err(why) => panic!("erro ao criar {}: {}", display, why),
        Ok(file) => file,
    };
    match file.write_all(content.as_bytes()) {
        Err(why) => panic!("erro ao escrever em {}: {}", display, why),
        Ok(_) => (),
    }
}
