extern crate yaml_rust;

use iolaus::data_types::ExamHeader;
use iolaus::utils;
use std::path::Path;
use yaml_rust::{Yaml, YamlLoader};

pub fn get(path: &Path) -> ExamHeader {
    let file_path = path.to_str().expect("Erro #0201");
    let content = utils::read_file_content(path);
    let docs = match YamlLoader::load_from_str(&content) {
        Err(_) => panic!("{}: formato YML inválido", file_path),
        Ok(docs) => docs,
    };
    let doc = &docs[0];

    ExamHeader {
        institute: parse_string("instituição", doc, file_path),
        departament: parse_string("departamento", doc, file_path),
        subject: parse_string("disciplina", doc, file_path),
        professor: parse_string("professor", doc, file_path),
        date: parse_string("data", doc, file_path),
        instructions: parse_string("instruções", doc, file_path),
    }
}

fn parse_string(parameter: &str, doc: &Yaml, file_path: &str) -> String {
    match doc[parameter].as_str() {
        Some(item) => item.to_string(),
        None => panic!("{}: {} não especificado(a)", file_path, parameter),
    }
}
