use iolaus::data_types::Student;
use iolaus::utils;
use std::path::Path;

pub fn get(file_path: &Path) -> Vec<Student> {
    let content = utils::read_file_content(file_path);
    let mut counter = 0u16;
    content.lines()
        .filter(|line| !line.trim().is_empty())
        .map(|line| { 
            counter = counter + 1;
            parse(line, counter)
        })
        .collect()
}

fn parse(line: &str, counter: u16) -> Student {
    let splitted: Vec<&str> = line.split(",").collect();
    if splitted.len() != 2 {
        panic!("alunos.csv, linha {}: formato incorreto", counter);
    }
    Student {
        name: splitted[0].to_owned(),
        registration: splitted[1].to_owned(),
    }
}
