use iolaus::data_types::{Exam, Question, Student};
use rand::{thread_rng, Rng};

pub fn process(students: Vec<Student>, questions: Vec<Vec<Question>>) -> Vec<Exam> {
    let mut exams = Vec::new();
    let mut index = 0;
    for student in students {
        let mut exam_questions = Vec::new();
        for same_question_list in &questions {
            let q = same_question_list[index].clone();
            exam_questions.push(q);
        }
        index = index + 1;
        thread_rng().shuffle(&mut exam_questions);
        exams.push(Exam {
            student,
            questions: exam_questions,
        });
    }
    exams
}
