use iolaus::data_types::{Config, PlainQuestion, Question};
use rand::{thread_rng, Rng};

pub fn process(plain_question: &PlainQuestion, config: &Config,) -> Question {
    let (alternatives, answer) = parse(plain_question, config);
    Question {
        stem: plain_question.stem.clone(),
        alternatives,
        answer,
    }
}

fn parse(plain_question: &PlainQuestion, config: &Config) -> (Vec<String>, u8) {
    let mut alternatives = plain_question.alternatives.clone();
    let mut rng = thread_rng();
    rng.shuffle(&mut alternatives);
    alternatives.truncate((config.n_alternatives - 1) as usize); 
    let answer = rng.gen_range(0, config.n_alternatives);
    alternatives.insert(answer as usize, plain_question.answer.clone());
    (alternatives, answer)
}
